pub struct TargetCpu {
    pub target_cpu: &'static str,
    pub target_arch: &'static str,
    pub target_features: &'static [&'static str],
}

pub const TARGET_CPUS: &[TargetCpu] = &[
    TargetCpu {
        target_cpu: "v4",
        target_arch: "x86_64",
        target_features: &[
            "avx",
            "avx2",
            "avx512bw",
            "avx512cd",
            "avx512dq",
            "avx512f",
            "avx512vl",
            "bmi1",
            "bmi2",
            "cmpxchg16b",
            "f16c",
            "fma",
            "fxsr",
            "lzcnt",
            "movbe",
            "popcnt",
            "sse",
            "sse2",
            "sse3",
            "sse4.1",
            "sse4.2",
            "ssse3",
            "xsave",
        ],
    },
    TargetCpu {
        target_cpu: "v3",
        target_arch: "x86_64",
        target_features: &[
            "avx",
            "avx2",
            "bmi1",
            "bmi2",
            "cmpxchg16b",
            "f16c",
            "fma",
            "fxsr",
            "lzcnt",
            "movbe",
            "popcnt",
            "sse",
            "sse2",
            "sse3",
            "sse4.1",
            "sse4.2",
            "ssse3",
            "xsave",
        ],
    },
    TargetCpu {
        target_cpu: "v2",
        target_arch: "x86_64",
        target_features: &[
            "cmpxchg16b",
            "fxsr",
            "popcnt",
            "sse",
            "sse2",
            "sse3",
            "sse4.1",
            "sse4.2",
            "ssse3",
        ],
    },
    TargetCpu {
        target_cpu: "v8.3a",
        target_arch: "aarch64",
        target_features: &[
            "crc", "dpb", "fcma", "jsconv", "lse", "neon", "paca", "pacg", "rcpc", "rdm",
        ],
    },
];
